//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "GraphLineDialog.h"
#include "GraphLineEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphLineDialog dialog


CGraphLineDialog::CGraphLineDialog(SGraph *m_graph)
	: CDialog(CGraphLineDialog::IDD, NULL)
{
	graph = m_graph;

	//{{AFX_DATA_INIT(CGraphLineDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CGraphLineDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphLineDialog)
	DDX_Control(pDX, IDC_LINE_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGraphLineDialog, CDialog)
	//{{AFX_MSG_MAP(CGraphLineDialog)
	ON_BN_CLICKED(IDC_NEW_BUTTON, OnNewButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphLineDialog message handlers

void CGraphLineDialog::OnNewButton() 
{
	SLineObject tmpLine;
	
	CGraphLineEdit gleDlg(&tmpLine);

	if(gleDlg.DoModal() == IDOK){
		// Make sure the line is consistent with the scale type
		if((tmpLine.GetVarType() == SLineObject::X) &&  
			(graph->x_scaleType == SCALE_LOG)){
			if(tmpLine.GetValue() <= 0.0f){
				AfxMessageBox("Can't plot slected line on a log scale!");
				return;
			}
		}

		if((tmpLine.GetVarType() == SLineObject::Y) &&  
			(graph->y_scaleType == SCALE_LOG)){
			if(tmpLine.GetValue() <= 0.0f){
				AfxMessageBox("Can't plot slected line on a log scale!");
				return;
			}
		}

		if((tmpLine.GetVarType() == SLineObject::X) &&  
			(graph->x_scaleType == SCALE_LOG)){
		}

		graph->lines.Push(tmpLine);

		CString buffer;

		if(tmpLine.GetVarType() == SLineObject::X){
			buffer.Format("x = %g", tmpLine.GetValue());
		}
		else{ //graph->lines[i].GetVarType() == SLineObject::Y
			buffer.Format("y = %g", tmpLine.GetValue());
		}

		m_list.AddString(buffer);
	}
}

void CGraphLineDialog::OnDeleteButton() 
{
	if(m_list.GetCurSel() != LB_ERR){
		// Remove the selected line from the graph
		if(m_list.GetCurSel() < graph->lines.Length()){
			graph->lines.Remove(m_list.GetCurSel());
			m_list.DeleteString(m_list.GetCurSel());
		}
	}
	else{
		AfxMessageBox("Please select a line to delete!");
	}
}

BOOL CGraphLineDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// load the list control with line items
	for(int i = 0;i < graph->lines.Length();i++){
		CString buffer;

		if(graph->lines[i].GetVarType() == SLineObject::X){
			buffer.Format("x = %g", graph->lines[i].GetValue());
		}
		else{ //graph->lines[i].GetVarType() == SLineObject::Y
			buffer.Format("y = %g", graph->lines[i].GetValue());
		}

		m_list.AddString(buffer);
	}

	return TRUE;
}
