//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#include "stdafx.h"
#include "sgraph.h"
#include "GraphLineEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphLineEdit dialog


CGraphLineEdit::CGraphLineEdit(SLineObject *m_line_ptr)
	: CDialog(CGraphLineEdit::IDD, NULL)
{
	line_ptr = m_line_ptr;

	//{{AFX_DATA_INIT(CGraphLineEdit)
	m_value = 0.0f;
	//}}AFX_DATA_INIT
}


void CGraphLineEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphLineEdit)
	DDX_Control(pDX, IDC_STYLE_COMBO, m_style);
	DDX_Control(pDX, IDC_AXIS_COMBO, m_axis);
	DDX_Text(pDX, IDC_VALUE_EDIT, m_value);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGraphLineEdit, CDialog)
	//{{AFX_MSG_MAP(CGraphLineEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphLineEdit message handlers

BOOL CGraphLineEdit::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_value = line_ptr->GetValue();
	m_style.SetCurSel(line_ptr->GetLineType());
	m_axis.SetCurSel(line_ptr->GetVarType());

	UpdateData(FALSE /* Initialize dialog */);

	return TRUE;
}

void CGraphLineEdit::OnOK() 
{
	UpdateData(TRUE);
	
	line_ptr->SetLineType(m_style.GetCurSel());
	line_ptr->SetVar(m_axis.GetCurSel(), m_value);

	CDialog::OnOK();
}
