//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#if !defined(AFX_MOVIEDIALOG_H__D4AC26F8_9F96_4592_A49C_AB228BDC9F90__INCLUDED_)
#define AFX_MOVIEDIALOG_H__D4AC26F8_9F96_4592_A49C_AB228BDC9F90__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MovieDialog.h : header file
//

#include "vfw.h"

/////////////////////////////////////////////////////////////////////////////
// CMovieDialog dialog

class CMovieDialog : public CDialog
{
// Construction
public:
	CMovieDialog(CView* pView);
	~CMovieDialog();
	BOOL OnInitDialog();
	
	// Initialize the AVI rendering code
	BOOL RenderInit();

	// Clean up the AVI rendering code
	void RenderClose();

	// Render a single frame of the AVI movie
	void RenderPlot(int cur_plot);

	CView* m_pView;
	
	BOOL render_all;
	int current_step;
	
	// AVI stream info
	PAVIFILE aviFile;
	PAVISTREAM aviStream;
	PAVISTREAM aviStreamCompressed;
	AVISTREAMINFO aviInfo;
	BITMAPINFO bmpInfoInput;
	BITMAPINFO bmpInfoOutput;
	
	COMPVARS compressOpts;

	// Bitmap (DIB) buffer info
	CDC renderDC;

	HBITMAP hDib;
	HGDIOBJ hOldDib;
	
	LPVOID pBitmapBits;
	int bitmapSize;
	int frames_written;

// Dialog Data
	//{{AFX_DATA(CMovieDialog)
	enum { IDD = IDD_MOVIE_DIALOG };
	CSpinButtonCtrl	m_spin_width;
	CSpinButtonCtrl	m_spin_stop;
	CSpinButtonCtrl	m_spin_start;
	CSpinButtonCtrl	m_spin_height;
	CSpinButtonCtrl	m_spin_fps;
	CProgressCtrl	m_progress;
	int		m_fps;
	int		m_height;
	CString	m_name;
	int		m_start;
	int		m_stop;
	int		m_width;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMovieDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMovieDialog)
	afx_msg void OnRadioAll();
	afx_msg void OnRadioSelected();
	afx_msg void OnButtonBrowse();
	afx_msg void OnRecord();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MOVIEDIALOG_H__D4AC26F8_9F96_4592_A49C_AB228BDC9F90__INCLUDED_)
