//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __EQUATION_UTIL
#define __EQUATION_UTIL

#include "Equation.h"

// Helper functions
EqElemVal *GetNextConstVal(EqElem *ptr, int &sop, int type);
BOOL FindIdentical(EqElem **tmp_L, EqElem **tmp_R, int op);

EqElem* MakeConst(double m_const, EqElem* m_p);

char *MatchUnaryBrace(char l_brace, char *buffer);
int MatchUnaryBrace(list<EqToken> &m_tokenlist, int m_i);

BOOL isBinaryOp(int m_token_type);
BOOL isUnaryOp(int m_token_type);
BOOL isValueOp(int m_token_type);

BOOL isElemZero(EqElem *m_ptr);
BOOL isElemOne(EqElem *m_ptr);

BOOL needsBrace(int m_token_type);
int braceSum(list<EqToken> &m_tokenlist);
int numValue(list<EqToken> &m_tokenlist, int m_start, int m_stop);

int GetOp(EqElem *tmp_L, EqElem *tmp_R, EqElemBinary *tmp_P);

#ifdef _DEBUG
void CheckTree(EqElem* ptr);
#endif // _DEBUG

// Some helpfull macros
#define		BINARY(X)	((EqElemBinary*)X)
#define		UNARY(X)	((EqElemUnary*)X)
#define		VALUE(X)	((EqElemVal*)X)

#endif // __EQUATION_UTIL