//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

#ifndef __HISTORY
#define __HISTORY

// Classes for persistent history

class EquationInfo{
public:
	CString	m_equation;
	UINT	m_num_points;
	CString	m_x_max;
	CString	m_x_min;

	BOOL operator == (const EquationInfo &m_copy)
	{
		if(m_equation != m_copy.m_equation)
			return FALSE;
		else{
			// If not equation has been stored, then the 
			// two EquationInfos are equivalent (no matter what the 
			// other entries are).
			if((m_equation == "") && (m_copy.m_equation == ""))
				return TRUE;
		}

		if(m_num_points != m_copy.m_num_points)
			return FALSE;

		if(m_x_max != m_copy.m_x_max)
			return FALSE;

		if(m_x_min != m_copy.m_x_min)
			return FALSE;

		return TRUE;
	}
};

class ParametricEquationInfo{
public:
	UINT	m_num_points;
	CString	m_t_max;
	CString	m_t_min;
	CString	m_x_of_t;
	CString	m_y_of_t;

	BOOL operator == (const ParametricEquationInfo &m_copy)
	{
		if(m_x_of_t != m_copy.m_x_of_t)
			return FALSE;

		if(m_y_of_t != m_copy.m_y_of_t)
			return FALSE;

		// If not equation has been stored, then the 
		// two ParametricEquationInfo are equivalent (no matter what the 
		// other entries are).
		if((m_x_of_t == "") && (m_copy.m_x_of_t == "") &&
		   (m_y_of_t == "") && (m_copy.m_y_of_t == ""))
			return TRUE;

		if(m_num_points != m_copy.m_num_points)
			return FALSE;

		if(m_t_max != m_copy.m_t_max)
			return FALSE;

		if(m_t_min != m_copy.m_t_min)
			return FALSE;

		return TRUE;
	}
};

class PolarEquationInfo{
public:
	CString	m_equation;
	UINT	m_num_points;
	CString	m_t_max;
	CString	m_t_min;

	BOOL operator == (const PolarEquationInfo &m_copy)
	{
		if(m_equation != m_copy.m_equation)
			return FALSE;
		else{
			// If not equation has been stored, then the 
			// two EquationInfos are equivalent (no matter what the 
			// other entries are).
			if((m_equation == "") && (m_copy.m_equation == ""))
				return TRUE;
		}

		if(m_num_points != m_copy.m_num_points)
			return FALSE;

		if(m_t_max != m_copy.m_t_max)
			return FALSE;

		if(m_t_min != m_copy.m_t_min)
			return FALSE;

		return TRUE;
	}
};

class FitEquationInfo{
public:
	CString	m_equation;

	BOOL operator == (const FitEquationInfo &m_copy)
	{
		return m_equation == m_copy.m_equation;
	}
};

#endif // __HISTORY