//	(c) 2000 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.

// Allow the user to pass options to sgraph via an imported text file

#ifndef __PARSE_OPTIONS
#define __PARSE_OPTIONS

#define	PARSE_OPTIONS_DATA						1
#define	PARSE_OPTIONS_NO_DATA					0
#define	PARSE_OPTIONS_ERROR						-1
#define PARSE_OPTIONS_ERROR_MALFORMED			-2
#define	PARSE_OPTIONS_ERROR_BAD_INDEX			-3
#define	PARSE_OPTIONS_ERROR_BAD_POINT_STYLE		-4
#define	PARSE_OPTIONS_ERROR_BAD_LINE_STYLE		-5
#define	PARSE_OPTIONS_ERROR_BAD_LINE_SIZE		-6
#define	PARSE_OPTIONS_ERROR_BAD_POINT_SIZE		-7
#define	PARSE_OPTIONS_ERROR_BAD_POINT_COLOR		-8
#define	PARSE_OPTIONS_ERROR_BAD_LINE_COLOR		-9
#define	PARSE_OPTIONS_ERROR_BAD_ERROR_BAR		-10
#define	PARSE_OPTIONS_ERROR_BAD_CUSTOM_COLOR	-11
#define	PARSE_OPTIONS_ERROR_BAD_GRAPH_DATA		-12
#define	PARSE_OPTIONS_ERROR_BAD_XAXIS_TILE		-13
#define	PARSE_OPTIONS_ERROR_BAD_YAXIS_TILE		-14

#include "list.h"

class ImportOptions{
private:
	int ParseSet(char *buffer);
	int ParseGraph(char *buffer);
public:
	int set_index;
	int set_pointType;
	int set_pointSize;
	int set_lineType;
	int set_lineSize;
	int set_lineColor;
	int set_pointColor;
	int set_errorBarDisplay;
	int set_info_flag;

	CString graph_title;
	CString graph_xaxis_title;
	CString graph_yaxis_title;
	CString set_info;

	ImportOptions()
	{
		set_index = -1;
		set_pointType = -1;
		set_pointSize = -1;
		set_lineType = -1;
		set_lineSize = -1;
		set_lineColor = -1;
		set_pointColor = -1;
		set_errorBarDisplay = -1;
		set_info_flag = -1;

		graph_title = _T("");
		graph_xaxis_title = _T("");
		graph_yaxis_title = _T("");
		set_info = _T("");
	};
	
	ImportOptions& operator=(const ImportOptions& copy);

	int Parse(char *buffer);
	int ParseRBGColor(char *ptr, int &clr);
};

class ImportOptionList{
private:
	list<ImportOptions> opt_list;

public:
	
	void Add(ImportOptions &opt);
	int GetOption(int i, ImportOptions &opt);

	CString GraphTitle();
	CString XAxisTitle();
	CString YAxisTitle();
};


#endif // __PARSE_OPTIONS
