//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __PRESTO_H
#define __PRESTO_H

#define		WM_STOP_PIPE		(WM_USER + 5)
#define		WM_PIPE_STATUS		(WM_USER + 6)

// Error codes
enum {S_ERROR_IO_OPEN = 1, S_ERROR_NO_DATA, S_ERROR_IO,
	  S_ERROR_IO_BUFFER, S_ERROR_IO_NUM_COL, S_ERROR_IO_FLOAT,
	  S_ERROR_MEM_ALLOC, S_ERROR_AUDIO};

enum {SCALE_LINEAR = 0, SCALE_LOG};

// Define index numbers for the status bar
enum {INFO_PANE = 0, XY_PANE, GRAPH_PANE};

// When importing data, any comments after S_COMMENT_CHAR
// are ignored.
#define	S_COMMENT_CHAR	'#'

#define	MAX_POINT_SIZE	10
#define	MAX_LINE_SIZE	10

// The default number of major and minor tick marks
#define	NUM_MAJOR_TICK	5
#define	NUM_MINOR_TICK	10

// Screen rendering limitations. Note that the "32 bit" minimum and
// maximum values are not a full 32 bits! No idea why not but the current
// values have been determined by hand on a windows 2000 (service pack 1) 
// machine.
#define		GDI_16_BIT_MAX		32766.0f
#define		GDI_16_BIT_MIN		-32767.0f

//#define		GDI_32_BIT_MAX		2147483647.0f
//#define		GDI_32_BIT_MIN		-2147483648.0f

#define		GDI_32_BIT_MAX		20000000.0f
#define		GDI_32_BIT_MIN		-20000000.0f

// The approximate maximum number of string entries in a
// CListBox object
#define		MAX_LIST_BOX_ENTRIES	3600

// The floating point precision used in PrestoPlot
#define		FP_PRECISION		1.0e-7

#define		QUICK_PLOT_STEPS	100

// Default layout
const float DefaultWidth = 0.75f;
const float DefaultHeight = 0.75f;

const float DefaultStartX = 0.5f*(1.0f - DefaultWidth);
const float DefaultStartY = 0.5f*(1.0f - DefaultHeight);

const float DefaultVGap = 0.1f;
const float DefaultHGap = 0.1f;

const float DefaultLegendSymbolWidth = 0.075f;

const char DefaultFont[] = "Times New Roman";

const int DefaultGraphTitleFontSize = -21;
const int DefaultAxisLabelFontSize = -14;
const int DefaultTickFontSize = -12;
const int DefaultTextFontSize = -14;
const int DefaultLegendFontSize = -14;

#define		PRESTO_DEFAULT_TITLE			"Graph"
#define		PRESTO_DEFAULT_Y_AXIS_LABLE		"Y Axis"
#define		PRESTO_DEFAULT_X_AXIS_LABLE		"X Axis"

//#define		PRESTO_DEFAULT_TITLE			""
//#define		PRESTO_DEFAULT_Y_AXIS_LABLE		""
//#define		PRESTO_DEFAULT_X_AXIS_LABLE		""

#endif // __PRESTO_H