//	(c) 2000-2002 J. Gans (jdg9@cornell.edu), Shalloway Lab, 
//	Cornell University. You can modify and freely distribute 
//	this code, but please keep this header intact.
#ifndef __SLEGEND
#define __SLEGEND

#include "splot.h"
#include "list.h"

class SLegend: public SObject {
private:
	// A pointer to the list of plots contained in the graph
	list<SPlot> *plot;

public:

	BOOL isBoundingBox;
	COLORREF fillColor;
	COLORREF edgeColor;

	// A boundary to give some space for the different legend items
	int LegendCushion;

	// Legend font
	LOGFONT font;
	COLORREF fontColor;

	SLegend(list<SPlot> &m_plot);

	// We need to use an overloaded "=" operator to avoid
	// shallow copy semantics with the pointer to a list of
	// plots. We DON'T want to copy the pointer -- just legend
	// attributes.
	SLegend& operator=(SLegend& m_copy)
	{
		// Note that plot != m_copy.plot (as per the comment above)

		// Copy all of the base class data
		SObject::operator=(m_copy);

		isBoundingBox = m_copy.isBoundingBox;
		fillColor = m_copy.fillColor;
		edgeColor = m_copy.edgeColor;
		LegendCushion = m_copy.LegendCushion;
		font = m_copy.font;
		fontColor = m_copy.fontColor;

		return *this;
	};

	virtual void Serialize(CArchive& ar);

	void Draw(CDC* pDC, CRect &extent);
	void DrawSelect(CDC* pDC, CRect &extent);

	CSelectRect SelectRect(CDC* pDC, CRect &extent);

	void PreparePrinting(CDC* pDC, long scaleMul, long scaleDiv, CRect &extent);
	void CleanUpPrinting(CDC* pDC, CRect &extent);

	void OnDelete();
};

#endif // __SLEGEND